﻿using UnityEngine;
using System.Collections;

public class Building : MonoBehaviour {
	public GameObject top;

	public GameObject front;
	public GameObject back;
	public GameObject right;
	public GameObject left;

	private Vector3 homeLocation;

	// Use this for initialization
	void Start () {
		// disable gravity 
		

		// initially disable the sides
		//HideBuilding();
	}
	
	// Update is called once per frame
	void Update () {

	}

	public void ShowBuilding() {
		Renderer[] sides = GetComponentsInChildren<Renderer>();
		foreach (Renderer rend in sides) {
			rend.enabled = true;
		}
	}

	public void HideBuilding() {
		Renderer[] sides = GetComponentsInChildren<Renderer>();
		foreach (Renderer rend in sides) {
			rend.enabled = false;
		}
	}

	public void DropIn() {
		transform.position = new Vector3(transform.position.x, transform.position.y+50, transform.position.z);
		GetComponent<Rigidbody>().useGravity = true;
	}

	public void buildFromData(BuildingData data, Vector3 newLocation) {
		string floors = data.floors;

		// update size of floors, based on height
		float newHeight = 0.082f + (0.8799f*int.Parse(floors)) + 0.345f; 
		front.transform.localScale = new Vector3(front.transform.localScale.x, front.transform.localScale.y, newHeight);
		back.transform.localScale = new Vector3(back.transform.localScale.x, back.transform.localScale.y, newHeight);
		right.transform.localScale = new Vector3(right.transform.localScale.x, right.transform.localScale.y, newHeight);
		left.transform.localScale = new Vector3(left.transform.localScale.x, left.transform.localScale.y, newHeight);
		
		front.transform.localPosition = new Vector3(front.transform.localPosition.x, front.transform.localScale.z*5, front.transform.localPosition.z);
		back.transform.localPosition = new Vector3(back.transform.localPosition.x, back.transform.localScale.z*5, back.transform.localPosition.z);
		right.transform.localPosition = new Vector3(right.transform.localPosition.x, right.transform.localScale.z*5, right.transform.localPosition.z);
		left.transform.localPosition = new Vector3(left.transform.localPosition.x, left.transform.localScale.z*5, left.transform.localPosition.z);
		
		top.transform.localPosition = new Vector3(top.transform.localPosition.x, front.transform.localScale.z*10, top.transform.localPosition.x);

		// adjust location
		transform.position = newLocation;
		homeLocation = newLocation;

		// initially hide
		HideBuilding();
	}

	public void SendToIntroLocation() {
		transform.position = new Vector3(-5000,0,0);
	}

	public void SendToHomeLocation() {
		transform.position = homeLocation;
	}

	/*
	public void loadMetadata(int id) {
		metadataLoader = new WWW ("https://dl.dropboxusercontent.com/u/4015375/KidsDay2015/Building/"+id+"/BuildingData.plist");
		StartCoroutine( LoadMetaDataCoroutine() );
	}

	IEnumerator LoadMetaDataCoroutine() {
		yield return metadataLoader;
		
		if (metadataLoader.error == null) {
			processTextData(metadataLoader.text);
		}
		else {
			Debug.Log("WWW Error: "+ metadataLoader.error);
		}
	}


	private void processTextData(string data) {
		// split return data by <key> parameter
		// -- could also parse XML
		disableSides();

		string[] seperators = new string[] {"<key>"};
		string[] split = metadataLoader.text.Split(seperators, System.StringSplitOptions.RemoveEmptyEntries);
		
		
		string floors = getIntegerFromData(split[1]);
		Debug.Log ("Floors: "+floors);

		// update size of floors, based on height
		// TO DO -----
		float newHeight = 0.082f + (0.8799f*int.Parse(floors)) + 0.345f; 
		front.transform.localScale = new Vector3(front.transform.localScale.x, front.transform.localScale.y, newHeight);
		back.transform.localScale = new Vector3(back.transform.localScale.x, back.transform.localScale.y, newHeight);
		right.transform.localScale = new Vector3(right.transform.localScale.x, right.transform.localScale.y, newHeight);
		left.transform.localScale = new Vector3(left.transform.localScale.x, left.transform.localScale.y, newHeight);

		front.transform.localPosition = new Vector3(front.transform.localPosition.x, front.transform.localScale.z*5, front.transform.localPosition.z);
		back.transform.localPosition = new Vector3(back.transform.localPosition.x, back.transform.localScale.z*5, back.transform.localPosition.z);
		right.transform.localPosition = new Vector3(right.transform.localPosition.x, right.transform.localScale.z*5, right.transform.localPosition.z);
		left.transform.localPosition = new Vector3(left.transform.localPosition.x, left.transform.localScale.z*5, left.transform.localPosition.z);

		top.transform.localPosition = new Vector3(top.transform.localPosition.x, front.transform.localScale.z*10, top.transform.localPosition.x);

		string index = getIntegerFromData(split[2]);
		Debug.Log("Index: "+index);
		
		updateTextures(index);
	}
	*/

	public void updateTextures(int id) {
		
		//string url = GameController.currentPath + "Building/"+id+"/building.jpg";
		
		GetComponent<Rigidbody>().useGravity = false;
		
		Texture tex = Resources.Load("Building/"+id+"/building") as Texture;
			
			front.GetComponent<Renderer>().material.SetTexture("_MainTex", tex);
			back.GetComponent<Renderer>().material.SetTexture("_MainTex", tex);
			right.GetComponent<Renderer>().material.SetTexture("_MainTex", tex);
			left.GetComponent<Renderer>().material.SetTexture("_MainTex", tex);
			
			// drop into scene
			ShowBuilding();
			
			
			DropIn();
			
			
			// tell GameController to start the Panel Timer
			GameObject.FindGameObjectWithTag("GameController").GetComponent<GameController>().StartPanelTimer();
			
			
	}



	/*
	// Utility Methods --------------------------------
	public string getIntegerFromData(string data) {
		string[] seperator = new string[] {"<integer>"};
		string[] split = data.Split(seperator, System.StringSplitOptions.RemoveEmptyEntries);
		
		string backHalf = split[1];
		seperator = new string[] {"</integer>"};
		split = backHalf.Split(seperator, System.StringSplitOptions.RemoveEmptyEntries);
		
		return split[0];
	}
	
	
	public string getStringFromData(string data) {
		string[] seperator = new string[] {"<string>"};
		string[] split = data.Split(seperator, System.StringSplitOptions.RemoveEmptyEntries);
		
		string backHalf = split[1];
		seperator = new string[] {"</string>"};
		split = backHalf.Split(seperator, System.StringSplitOptions.RemoveEmptyEntries);
		
		return split[0];
	}
	*/
}
