﻿using UnityEngine;
using System.Collections;

public class Hero : MonoBehaviour {
	public GameObject mesh;
	public GameObject armature;

	public HeroData data;

	private WWW metadataLoader;

	private Animator currentAnimator;

	public RuntimeAnimatorController mecanimController;
	public RuntimeAnimatorController blenderController;

	private bool shouldAnimate;
	private float speed;

	private string waitingAction;

	// Use this for initialization
	void Start () {
		//HideHero();
		
	}
	
	// Update is called once per frame
	void Update () {
		if (shouldAnimate) {
			gameObject.transform.Translate(Vector3.forward * Time.deltaTime * speed);
		}
	}

	public void MoveTo( Vector3 loc ) {
		gameObject.transform.position = loc;
	}

	public void RotateTo( Vector3 rot ) {
		gameObject.transform.eulerAngles = new Vector3( gameObject.transform.eulerAngles.x+rot.x, gameObject.transform.eulerAngles.y+rot.y, gameObject.transform.eulerAngles.z+rot.z );
	}

	public void AnimateForward(float newSpeed) {
		speed = newSpeed;
		shouldAnimate = true;

	}

	public void ResetLocation() {
		shouldAnimate = false;

		
		//AssignMecanimAction(Constants.ACTION_TPOSE);
		//AssignMecanimAction(Constants.ACTION_DANCE);
			
		//AssignBlenderAction(Constants.ACTION_BASE);
		//currentAnimator.enabled = false;
		
		//currentAnimator.StopPlayback();

		//AssignMecanimAction("");

		// reset rotation
		//RotateTo( new Vector3(0,180,0) );


		gameObject.transform.eulerAngles = new Vector3(0,180,0);
		armature.transform.eulerAngles = new Vector3(270,0,0);

		// Move far offscreen
		gameObject.transform.position = new Vector3(8000,0,0);


	}

	// Called up completion of texture loads
	void heroLoadComplete() {
	
		// Tell the GameController to switch to Hero Intro Panel
		/*
		if (int.Parse(data.index) == HeroManager.nextIndex) {
			GameObject.FindGameObjectWithTag("GameController").GetComponent<GameController>().ChangePanel( new Panel_HeroIntro() );
		}
		else {
			HeroManager.SendToLimbo(this);
		}
		*/
		
		HeroManager.SendToLimbo(this);
		
		//GameObject.FindGameObjectWithTag("GameController").GetComponent<GameController>().ChangePanel( new Panel_HeroIntro() );

		//GameObject.FindGameObjectWithTag("GameController").GetComponent<GameController>().currentPanel = new Panel_HeroIntro();
	}

	// Show/Hide hero --------------------------------
	public void HideHero() {
		Renderer[] sides = GetComponentsInChildren<Renderer>();
		foreach (Renderer rend in sides) {
			rend.enabled = false;
		}

	}
	
	public void ShowHero() {
		Renderer[] sides = GetComponentsInChildren<Renderer>();
		foreach (Renderer rend in sides) {
			rend.enabled = true;
		}
	}

	// Action methods --------------------------------

	public void AssignMecanimAction(string actionID) {

		currentAnimator.runtimeAnimatorController = mecanimController;
		//currentAnimator.enabled = true;

		currentAnimator.SetTrigger(actionID);
	}
	public void PerformWaitingMecanimAction() {
		Debug.Log("2---- invoke");
		AssignMecanimAction(waitingAction);
	}

	public void AssignBlenderAction(string actionID) {
		currentAnimator.runtimeAnimatorController = blenderController;
		//currentAnimator.enabled = true;

		currentAnimator.SetTrigger(actionID);

	}
	public void PerformWaitingBlenderAction() {
		AssignBlenderAction(waitingAction);
	}

	public void AssignTimedMecanimAction(string actionID, float time) {
		waitingAction = actionID;
		Debug.Log("1---- waiting to invoke");
		Invoke("PerformWaitingMecanimAction", time);
	}
	public void AssignTimedBlenderAction(string actionID, float time) {
		waitingAction = actionID;
		Invoke("PerformWaitingBlenderAction", time);
	}

	
	
	// Texture Download Methods ------------------------------

	public void updateTextures(int id) {
		
		shouldAnimate= false;
		
		
		currentAnimator = GetComponent<Animator>();
		
		Texture tex = Resources.Load("Hero/"+id+"/hero") as Texture;
		mesh.GetComponent<Renderer>().material.SetTexture("_MainTex", tex);
		
		// Hero is ready
		heroLoadComplete();
	}

	
}
