﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class Panel {
	//public bool isInfinite;

	public float panelTime;
	public float startTime;

	public List<Hero> heroes;

	public Panel() {
		startTime = Time.time;
	}

	public virtual void UpdatePanel() {
		if (Time.time >= panelTime+startTime) {
			EndPanel();
		}
	}

	public virtual void StartTimer() {

	}

	public virtual void EndPanel() {

		GameObject.FindGameObjectWithTag("GameController").GetComponent<GameController>().LoadNextPanel();
	}

	public virtual void PanelCleanup() {
		// return all heroes to Limbo
		if (heroes!=null) {
			for (int i=0; i<heroes.Count; i++) {
				HeroManager.SendToLimbo( heroes[i] );
			}
		}
	}

}
