﻿using UnityEngine;
using System.Collections;

public class PreviewController : MonoBehaviour {
	public GameObject heroCamHolder;
	public GameObject buildingCamHolder;

	private float cameraOffset;

	private WWW textLoader;

	// Use this for initialization
	void Start () {
		cameraOffset = 4.0f;
	}
	
	// Update is called once per frame
	void Update () {
		// rotate building area
		buildingCamHolder.transform.eulerAngles = new Vector3 (buildingCamHolder.transform.eulerAngles.x, buildingCamHolder.transform.eulerAngles.y+12.0f*Time.deltaTime, buildingCamHolder.transform.eulerAngles.z);

		// hero camera
		heroCamHolder.transform.eulerAngles = new Vector3 (heroCamHolder.transform.eulerAngles.x, heroCamHolder.transform.eulerAngles.y+cameraOffset*Time.deltaTime, heroCamHolder.transform.eulerAngles.z);

		// adjust hero camera back/forth rotation
		if (heroCamHolder.transform.eulerAngles.y >= 30 && heroCamHolder.transform.eulerAngles.y<50) {
			cameraOffset = -4.0f;
		}
		else if (heroCamHolder.transform.eulerAngles.y <= 330 && heroCamHolder.transform.eulerAngles.y>310) {
			cameraOffset = 4.0f;
		}


		//InvokeRepeating("LoadDataEvent", 0, 5);

	}


	public void LoadDataEvent() {
		//textLoader = new WWW ("file:///Users/gpurcell/Dropbox/Public/KidsDay2015/HeroData.plist");
		textLoader = new WWW ("https://dl.dropboxusercontent.com/u/4015375/KidsDay2015/WorldData.plist");
		StartCoroutine( LoadDataCoroutine() );
	}
	
	IEnumerator LoadDataCoroutine() {
		yield return textLoader;
		
		if (textLoader.error == null) {
			Debug.Log("plist data: " + textLoader.text);
			
			processTextData(textLoader.text);
			
			//output.text = "Data Success";
		}
		else {
			Debug.Log("WWW Error: "+ textLoader.error);
			
			//output.text = "Err: "+textLoader.error;
		}
	}
	
	private void processTextData(string data) {
		// split return data by <key> parameter
		// -- could also parse XML
		string[] seperators = new string[] {"<key>"};
		string[] split = textLoader.text.Split(seperators, System.StringSplitOptions.RemoveEmptyEntries);
		
		// 0 is overhead data
		// 1 is index
		
		string buildingString = getIntegerFromData(split[1]);
		BuildingManager.nextIndex = int.Parse(buildingString);
		
		string heroString = getIntegerFromData(split[2]);
		HeroManager.nextIndex = int.Parse(heroString);
		
		// Update Hero Check
		//if (HeroManager.nextIndex == HeroManager.currentIndex+1) {
			GetComponent<HeroManager>().addNewHero();
		//}
		//else if (HeroManager.nextIndex > HeroManager.currentIndex) {
			//GetComponent<HeroManager>().addPreviousHeroes();
		//}
		
		// Update Building Check
		//if (BuildingManager.nextIndex == BuildingManager.currentIndex+1) {
			
			GetComponent<BuildingManager>().addNewBuilding();
			
			// switch to new Building intro
			//ChangePanel(new Panel_BuildingIntro() );
		//}
		//else if (BuildingManager.nextIndex > BuildingManager.currentIndex) {
			//Debug.Log("add Previous");
			
			//GetComponent<BuildingManager>().addPreviousBuildings();
		//}

		
	}
	
	
	// Utility Methods --------------------------------
	public string getIntegerFromData(string data) {
		string[] seperator = new string[] {"<integer>"};
		string[] split = data.Split(seperator, System.StringSplitOptions.RemoveEmptyEntries);
		
		string backHalf = split[1];
		seperator = new string[] {"</integer>"};
		split = backHalf.Split(seperator, System.StringSplitOptions.RemoveEmptyEntries);
		
		return split[0];
	}
	
	
	public string getStringFromData(string data) {
		string[] seperator = new string[] {"<string>"};
		string[] split = data.Split(seperator, System.StringSplitOptions.RemoveEmptyEntries);
		
		string backHalf = split[1];
		seperator = new string[] {"</string>"};
		split = backHalf.Split(seperator, System.StringSplitOptions.RemoveEmptyEntries);
		
		return split[0];
	}



}
