﻿using UnityEngine;
using System.Collections;

public class Panel_Batman : Panel {
	private Camera cam;
	private Hero theHero;
	GameController controller;

	public Panel_Batman() {
		Debug.Log("Current Panel: Batman");

		// set panel time
		panelTime = 10.0f;
		
		// make a reference to the GameController
		controller = GameObject.FindGameObjectWithTag("GameController").GetComponent<GameController>();
		
		// change camera
		controller.ShowPoseableCam();


		Building building = BuildingManager.GetRandomBuilding();
		float xVal = building.gameObject.transform.position.x - 11;
		float yVal = building.top.transform.position.y-0.3f;
		float zVal = building.gameObject.transform.position.z - 11;

		heroes = HeroManager.getRandomHeroes(1);
		theHero = heroes[0];

		theHero.MoveTo( new Vector3(xVal,yVal,zVal) );

		theHero.AssignMecanimAction(Constants.ACTION_CROUCH);
		//theHero.RotateTo( new Vector3(0,-160,0) );

		// camera control
		cam = controller.poseableCam;

		cam.transform.position = new Vector3 (theHero.gameObject.transform.position.x + 3, theHero.gameObject.transform.position.y - 8, theHero.gameObject.transform.position.z - 3   );
		cam.transform.LookAt(theHero.gameObject.transform.position);

		theHero.AssignTimedMecanimAction(Constants.ACTION_POWER_UP, 5.0f);
	}

	public override void UpdatePanel() {

		if (controller.currentPanel != null) {
			cam.transform.LookAt(theHero.gameObject.transform.position);
			cam.transform.Translate(Vector3.left * Time.deltaTime * 0.5f);
			cam.transform.Translate(Vector3.up * Time.deltaTime * 1.5f);
		}

		base.UpdatePanel();
	}

	public override void EndPanel() {
		
		base.EndPanel();
	}

	public override void PanelCleanup() {
		base.PanelCleanup();
	}
}
