﻿using UnityEngine;
using System.Collections;

public class Panel_BuildingIntro : Panel {
	private GameObject camHolder;
	private Camera cam;

	public Panel_BuildingIntro() {
		Debug.Log("Current Panel: Building Intro");

		// set panel time
		panelTime = 10.0f;

		// make a reference to the GameController
		GameController controller = GameObject.FindGameObjectWithTag("GameController").GetComponent<GameController>();
		
		// change camera
		controller.ShowRotatingCam();

		// create local references to Camera and Holder
		camHolder = GameObject.FindGameObjectWithTag("GameController").GetComponent<GameController>().rotatingCamHolder;
		camHolder.transform.position = new Vector3(-5000,0,0);

		cam = GameObject.FindGameObjectWithTag("GameController").GetComponent<GameController>().rotatingCam;
		cam.transform.localPosition = new Vector3(0,70,-90);
		cam.transform.LookAt( new Vector3(-5000,0,0) );

	}
	
	public override void UpdatePanel() {


		if (camHolder != null) {
			camHolder.transform.eulerAngles = new Vector3(camHolder.transform.eulerAngles.x, camHolder.transform.eulerAngles.y + 24.0f*Time.deltaTime, camHolder.transform.eulerAngles.z) ;

			/*
			if (!isInfinite) {
				if (Time.time >= startTime + panelTime)
					EndPanel();
			}
			*/

		}

		base.UpdatePanel();
			
	}

	public override void EndPanel() {


		base.EndPanel();
	}

	public override void PanelCleanup() {
		cam.transform.localPosition = new Vector3(0,15,-70);
		cam.transform.eulerAngles = new Vector3();

		camHolder.transform.position = new Vector3();
		camHolder.transform.eulerAngles = new Vector3();

		// return building to proper location in world
		BuildingManager.newestBuilding.SendToHomeLocation();


		base.PanelCleanup();

	}
}
