﻿using UnityEngine;
using System.Collections;

public class Panel_DanceParty : Panel {
	private GameObject camHolder;
	private Camera cam;
	
	public Panel_DanceParty() {
		Debug.Log("Current Panel: Dance Party");

		// set panel time
		// set panel time
		panelTime = 12.0f;
		
		// make a reference to the GameController
		GameController controller = GameObject.FindGameObjectWithTag("GameController").GetComponent<GameController>();
		
		// change camera
		controller.ShowPoseableCam();

		// position camera		
		cam = controller.poseableCam;
		cam.transform.localPosition = new Vector3(0,7,-60);
		
		
		// populate with heroes;
		heroes = HeroManager.getRandomHeroes(3);
		
		
		if (heroes != null) {
			// physically place hero
			for (int i=0; i<heroes.Count; i++) {
				heroes[i].ShowHero();
			}
			
			Hero1(heroes[0]);
			Hero2(heroes[1]);
			Hero3(heroes[2]);
		}
		else {
			Debug.Log("HEROES IS NULL");
		}
		
	}
	
	
	// Hero Specific Actions -----------------------------------------------
	void Hero1(Hero hero) {
		if (hero!=null) {
			hero.MoveTo(new Vector3(0,0,-52 ) );
			hero.AssignMecanimAction(Constants.ACTION_DANCE);
			
			Vector3 loc = hero.gameObject.transform.position;
			cam.transform.LookAt( new Vector3(loc.x, loc.y+4, loc.z) );
		}
	}
	
	void Hero2(Hero hero) {
		if (hero!=null) {
			hero.MoveTo(new Vector3(7,0,-45 ) );
			hero.AssignMecanimAction(Constants.ACTION_DANCE);
		}
	}
	
	void Hero3(Hero hero) {
		if (hero!=null) {
			hero.MoveTo(new Vector3(-7,0,-45 ) );
			hero.AssignMecanimAction(Constants.ACTION_DANCE);
		}
	}
	
	
}
