﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class Panel_Fight : Panel {
	private GameObject camHolder;
	private Camera cam;
	
	public Panel_Fight() {
		Debug.Log("Current Panel: Fight");

		// set panel time
		// set panel time
		panelTime = 8.0f;
		
		// make a reference to the GameController
		GameController controller = GameObject.FindGameObjectWithTag("GameController").GetComponent<GameController>();
		
		// change camera
		controller.ShowRotatingCam();
		
		camHolder = controller.rotatingCamHolder;
		camHolder.transform.position = new Vector3(-18,0,-18);
		camHolder.transform.eulerAngles = new Vector3(0,45,0);
		
		// position camera
		
		cam = controller.rotatingCam;
		cam.transform.localPosition = new Vector3(0,5.86f,-70);
		cam.transform.localEulerAngles = new Vector3();
		//cam.transform.LookAt( new Vector3() );
		
		
		// populate with heroes;
		heroes = HeroManager.getRandomHeroes(4);
		
		
		if (heroes != null) {
			// physically place hero
			for (int i=0; i<heroes.Count; i++) {
				heroes[i].ShowHero();
			}
			
			Hero1(heroes[0]);
			Hero2(heroes[1]);
			Hero3(heroes[2]);
			Hero4(heroes[3]);
		}
		else {
			Debug.Log("HEROES IS NULL");
		}
		
	}

	public override void UpdatePanel() {
		base.UpdatePanel();
		
		// rotate the camera
		//camHolder.transform.eulerAngles = new Vector3(camHolder.transform.eulerAngles.x, camHolder.transform.eulerAngles.y + 2.0f*Time.deltaTime, camHolder.transform.eulerAngles.z);
	}
	
	public override void EndPanel() {
		
		base.EndPanel();
	}
	
	public override void PanelCleanup() {
		base.PanelCleanup();
		
		// reset rotation
		camHolder.transform.position = new Vector3();
		camHolder.transform.eulerAngles = new Vector3(0,0,0);
		cam.transform.localPosition = new Vector3(0,15,-70);
	}
	
	// Hero Specific Actions -----------------------------------------------
	void Hero1(Hero hero) {
		if (hero!=null) {
			hero.MoveTo(new Vector3(-45f,0,-63.3f ) );
			hero.RotateTo( new Vector3(0,130,0) );
			hero.AssignMecanimAction(Constants.ACTION_POWER_UP);
			hero.AssignTimedMecanimAction(Constants.ACTION_WIN, 3.0f);
		}
	}
	
	void Hero2(Hero hero) {
		if (hero!=null) {
			hero.MoveTo(new Vector3(-47.9f,0,-47f ) );
			hero.RotateTo( new Vector3(0,30,0) );
			hero.AssignMecanimAction(Constants.ACTION_DUKES_UP);
			hero.AssignTimedMecanimAction(Constants.ACTION_PASS_OUT,1.0f);
		}
	}
	
	void Hero3(Hero hero) {
		if (hero!=null) {
			hero.MoveTo(new Vector3(-58.2f, 0, -44.7f ) );
			hero.AssignMecanimAction(Constants.ACTION_DUKES_UP);
			hero.AssignTimedMecanimAction(Constants.ACTION_PASS_OUT,1.0f);
			hero.RotateTo( new Vector3(0,-25,0) );
		}
	}
	
	void Hero4(Hero hero) {
		if (hero!=null) {
			hero.MoveTo(new Vector3(-60,0,-55 ) );
			hero.AssignMecanimAction(Constants.ACTION_DUKES_UP);
			hero.AssignTimedMecanimAction(Constants.ACTION_PASS_OUT,1.0f);
			//hero.AssignBlenderAction(Constants.ACTION_LANDING);
			hero.RotateTo( new Vector3(0,-30,0) );
		}
	}

}
