﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class Panel_FlyForward : Panel {
	private GameObject camHolder;
	private Camera cam;
	private Hero theHero;
	
	public Panel_FlyForward() {
		Debug.Log("Current Panel: Fly Forward");

		// set panel time
		// set panel time
		panelTime = 8.0f;
		
		// make a reference to the GameController
		GameController controller = GameObject.FindGameObjectWithTag("GameController").GetComponent<GameController>();
		
		// change camera
		controller.ShowHeroCam();
		
		// parent camera to current hero
		camHolder = controller.heroCamHolder;
		
		
		// position hero 
		// place at starting point in world (in front of LB building)
		
		// populate with heroes
		heroes = new List<Hero>();
		heroes.Add (HeroManager.getRandomHero() );
		theHero = heroes[0];
		
		// location
		Vector3 loc = BuildingManager.GetRandomIntersection();
		theHero.MoveTo( new Vector3(loc.x,loc.y+20,loc.z) );
		
		camHolder.transform.position = theHero.gameObject.transform.position;
		camHolder.transform.parent = theHero.gameObject.transform;
		
		cam = controller.heroCam;
		cam.transform.localPosition = new Vector3(0,-1,-9);
		cam.transform.localEulerAngles = new Vector3(-15,0,0);
		
		
		theHero.AssignBlenderAction(Constants.ACTION_FLYING_POSE1);
		
		theHero.AnimateForward(15);
		
		if (heroes != null) {
			// physically place hero
			for (int i=0; i<heroes.Count; i++) {
				heroes[i].ShowHero();
			}
		}
		
	}
	
	
	public override void UpdatePanel() {
		base.UpdatePanel();
		
		
	}
	
	
	public override void PanelCleanup () {
		base.PanelCleanup ();
		
		// return hero cam
		cam.transform.localPosition = new Vector3(0,4.15f,-9);
		cam.transform.localEulerAngles = new Vector3(10,0,0);;
	}
}
