﻿using UnityEngine;
using System.Collections;

public class Panel_FlyOver : Panel {
	private float xVal;
	private float zVal;

	public Panel_FlyOver() {
		Debug.Log("Current Panel: Fly Over");

		// set panel time
		panelTime = 5.0f;
		
		// make a reference to the GameController
		GameController controller = GameObject.FindGameObjectWithTag("GameController").GetComponent<GameController>();
		
		// change camera
		controller.ShowPoseableCam();
		
		// position camera
		Vector3 loc = BuildingManager.GetRandomIntersection();
		xVal = loc.x;
		zVal = loc.z;

		Debug.Log("flyover setup");
		Camera cam = controller.poseableCam;
		cam.transform.localPosition = new Vector3(xVal+4,0.5f,zVal);
		cam.transform.localEulerAngles = new Vector3(270,335,0);
		//cam.transform.LookAt( new Vector3(xVal,20,zVal) );


		// populate with heroes
		heroes = HeroManager.getRandomHeroes(3);
		
		
		if (heroes != null) {
			// physically place hero
			for (int i=0; i<heroes.Count; i++) {
				heroes[i].ShowHero();
			}
			
			Hero1(heroes[0]);
			Hero2(heroes[1]);
			Hero3(heroes[2]);
			
		}
		else {
			Debug.Log("HEROES IS NULL");
		}
	}

	public override void UpdatePanel() {
		base.UpdatePanel();
	}

	public override void EndPanel() {
		base.EndPanel();
	}

	public override void PanelCleanup() {
		base.PanelCleanup();
	}

	void Hero1(Hero hero) {
		if (hero!=null) {
			hero.MoveTo(new Vector3(xVal,15,zVal+40) );
			hero.AssignBlenderAction(Constants.ACTION_FLYING_POSE1);
			hero.AnimateForward(20);
		}
	}
	
	void Hero2(Hero hero) {
		if (hero!=null) {
			hero.MoveTo(new Vector3(xVal-5,25,zVal+40) );
			hero.AssignBlenderAction(Constants.ACTION_FLYING_POSE1);
			hero.AnimateForward(25);
		}
	}
	
	void Hero3(Hero hero) {
		if (hero!=null) {
			hero.MoveTo(new Vector3(xVal+5,19,zVal+40) );
			hero.AssignBlenderAction(Constants.ACTION_FLYING_POSE1);
			hero.AnimateForward(18);
		}
	}

}
