﻿using UnityEngine;
using System.Collections;

public class Panel_HeroIntro : Panel {
	private GameObject camHolder;

	public Panel_HeroIntro() {
		Debug.Log("Current Panel: Hero intro");

		// set panel time
		panelTime = 5.0f;

		// make a reference to the GameController
		GameController controller = GameObject.FindGameObjectWithTag("GameController").GetComponent<GameController>();

		// change camera
		controller.ShowHeroCam();

		// parent camera to current hero
		camHolder = controller.heroCamHolder;
		camHolder.transform.parent = null;
		camHolder.transform.position = new Vector3(0,0,-24);

		Camera cam = controller.heroCam;
		cam.transform.localPosition = new Vector3(0,4.15f,-8.99f);
		cam.transform.localEulerAngles = new Vector3(10,0,0);

		//camHolder.transform.parent = HeroManager.newestHero.gameObject.transform;


		// show the Hero
		HeroManager.newestHero.ShowHero();

		// position hero 
		// place at starting point in world (in front of LB building)
		HeroManager.newestHero.gameObject.transform.position = new Vector3(0, 0, -15);


		HeroManager.newestHero.AssignBlenderAction(Constants.ACTION_LANDING);

		/*
		// position the hero
		switch (HeroManager.newestHero.data.power1) {
		case Constants.POWER_FLIGHT:
			FlightIntro();
			break;
		case Constants.POWER_SUPER_SPEED:
			SpeedIntro();
			break;
		case Constants.POWER_LARGE:
			LargeIntro();
			break;
		case Constants.POWER_ENERGY:
			EnergyIntro();
			break;
		case Constants.POWER_STRENGTH:
			StrengthIntro();
			break;
		}
		*/

		//camHolder.transform.localPosition = new Vector3(0,0,13);
	}

	public override void UpdatePanel() {
		base.UpdatePanel();

	}
	
	public override void EndPanel() {
		// call parent
		base.EndPanel();
	}

	public override void PanelCleanup() {
		base.PanelCleanup();

		// Send newest hero to Limbo
		HeroManager.SendToLimbo(HeroManager.newestHero);
	}
	

}
