﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class Panel_HeroRun : Panel {
	private GameObject camHolder;
	private Hero theHero;

	public Panel_HeroRun() {
		Debug.Log("Current Panel: Hero Run");

		// set panel time
		// set panel time
		panelTime = 5.0f;
		
		// make a reference to the GameController
		GameController controller = GameObject.FindGameObjectWithTag("GameController").GetComponent<GameController>();
		
		// change camera
		controller.ShowHeroCam();
		
		// parent camera to current hero
		camHolder = controller.heroCamHolder;

		
		// position hero 
		// place at starting point in world (in front of LB building)
		
		// populate with heroes
		heroes = new List<Hero>();
		heroes.Add (HeroManager.getRandomHero() );
		theHero = heroes[0];
		theHero.MoveTo( new Vector3(-71,0,25) );

		camHolder.transform.position = theHero.gameObject.transform.position;
		camHolder.transform.parent = theHero.gameObject.transform;
		theHero.AssignMecanimAction(Constants.ACTION_RUN);

		if (heroes != null) {
			// physically place hero
			for (int i=0; i<heroes.Count; i++) {
				heroes[i].ShowHero();
			}
		}

	}

	public override void UpdatePanel() {
		base.UpdatePanel();
		
	}
	

	public override void PanelCleanup () {
		base.PanelCleanup ();
	}
}
