﻿using UnityEngine;
using System.Collections;

public class Panel_LBPanUp : Panel {
	private Camera cam;

	public Panel_LBPanUp() {
		Debug.Log("Current Panel: LBPanUp");

		// set panel time
		panelTime = 4.0f;

		// make a reference to the GameController
		GameController controller = GameObject.FindGameObjectWithTag("GameController").GetComponent<GameController>();

		// change camera
		controller.ShowPoseableCam();

		// position camera
		cam = controller.poseableCam;
		cam.transform.position = new Vector3(0, 20, -40);
		cam.transform.LookAt( new Vector3() );


	}

	public override void UpdatePanel() {

		cam.transform.position = new Vector3(cam.transform.position.x, cam.transform.position.y + 2.0f*Time.deltaTime, cam.transform.position.z);

		base.UpdatePanel();
	}

	public override void EndPanel() {
		
		// call parent
		base.EndPanel();
	}

	public override void PanelCleanup() {
		base.PanelCleanup();
	}
}
