﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class Panel_LBRotate : Panel {
	private GameObject camHolder;

	private Hero flyingHero;

	public Panel_LBRotate() {
		Debug.Log("Current Panel: LBRotate");

		// set panel time
		panelTime = 6.0f;

		// make a reference to the GameController
		GameController controller = GameObject.FindGameObjectWithTag("GameController").GetComponent<GameController>();
		
		// change camera
		controller.ShowRotatingCam();

		// position camera
		Camera cam = controller.rotatingCam;
		cam.transform.localPosition = new Vector3(0,15,-70);
		cam.transform.eulerAngles = new Vector3( 12,0,0 );

		// parent camera to current hero
		camHolder = controller.rotatingCamHolder;
		//camHolder.transform.parent = controller.gameObject.transform;

		// point to the center of the world
		camHolder.transform.position = new Vector3();
		camHolder.transform.eulerAngles = new Vector3();

		// populate with heroes;
		heroes = HeroManager.getRandomHeroes(5);


		if (heroes != null) {
			// physically place hero
			for (int i=0; i<heroes.Count; i++) {
				heroes[i].ShowHero();
			}

			Hero1(heroes[0]);
			Hero2(heroes[1]);
			Hero3(heroes[2]);
			Hero4(heroes[3]);
			Hero5(heroes[4]);

		}
		else {
			Debug.Log("HEROES IS NULL");
		}
	}

	public override void UpdatePanel() {

		// rotate the camera
		camHolder.transform.eulerAngles = new Vector3(camHolder.transform.eulerAngles.x, camHolder.transform.eulerAngles.y + 2.0f*Time.deltaTime, camHolder.transform.eulerAngles.z);

		base.UpdatePanel();
	}

	public override void EndPanel() {

		base.EndPanel();
	}

	public override void PanelCleanup() {
		base.PanelCleanup();
	}

	// Hero Specific Actions -----------------------------------------------
	void Hero1(Hero hero) {
		if (hero!=null) {
			hero.MoveTo(new Vector3(-23.8f,0,3.4f ) );
			hero.AssignMecanimAction(Constants.ACTION_JOG);


			//hero.RotateTo( new Vector3(0,-15,0) );
		}
	}

	void Hero2(Hero hero) {
		if (hero!=null) {
			hero.MoveTo(new Vector3(0,0,-15f ) );
			hero.AssignMecanimAction(Constants.ACTION_DUKES_UP);


			//hero.RotateTo( new Vector3(0,-15,0) );
		}
	}

	void Hero3(Hero hero) {
		if (hero!=null) {
			hero.MoveTo(new Vector3(50.8f,0,1.1f ) );
			hero.AssignMecanimAction(Constants.ACTION_RUN);
			hero.RotateTo( new Vector3(0,20,0) );
			//hero.RotateTo( new Vector3(0,-15,0) );
		}
	}

	void Hero4(Hero hero) {
		if (hero!=null) {
			hero.MoveTo(new Vector3(10.9f,0,-33.9f ) );
			hero.AssignBlenderAction(Constants.ACTION_TAKE_OFF);
			hero.RotateTo( new Vector3(0,30,0) );
			//hero.RotateTo( new Vector3(0,-15,0) );
		}
	}

	void Hero5(Hero hero) {
		if (hero!=null) {
			hero.MoveTo(new Vector3(-30.0f,20,33.9f ) );
			hero.AssignBlenderAction(Constants.ACTION_FLYING_POSE1);
			hero.RotateTo( new Vector3(0,-15,0) );
			hero.AnimateForward(40);

		}
	}
}
