﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class Panel_SlowWalk : Panel {
	private GameObject camHolder;
	private Hero theHero;
	private Vector3 loc;

	public Panel_SlowWalk() {
		Debug.Log("Current Panel: Slow Walk");

		// set panel time
		// set panel time
		panelTime = 5.0f;
		
		// make a reference to the GameController
		GameController controller = GameObject.FindGameObjectWithTag("GameController").GetComponent<GameController>();
		
		// change camera
		controller.ShowHeroCam();
		
		// parent camera to current hero
		camHolder = controller.heroCamHolder;

		loc = BuildingManager.GetRandomIntersection();

		// populate with heroes;
		heroes = HeroManager.getRandomHeroes(3);

		if (heroes != null) {
			// physically place hero
			for (int i=0; i<heroes.Count; i++) {
				heroes[i].ShowHero();
			}

			Hero1(heroes[0]);
			Hero2(heroes[1]);
			Hero3(heroes[2]);
		}
		
	}
	
	public override void UpdatePanel() {

		camHolder.transform.position = new Vector3(theHero.gameObject.transform.position.x, 0.0f, theHero.gameObject.transform.position.z);
		camHolder.transform.eulerAngles = new Vector3(0, camHolder.transform.eulerAngles.y-Time.deltaTime*4.0f, 0);

		base.UpdatePanel();
	}
	
	
	public override void PanelCleanup () {
		base.PanelCleanup ();

		camHolder.transform.eulerAngles = new Vector3();

		// Send newest hero to Limbo
		HeroManager.SendToLimbo(HeroManager.newestHero);
	}

	void Hero1(Hero hero) {
		if (hero!=null) {
			hero.MoveTo( new Vector3(loc.x,0,loc.z) );
			hero.AssignMecanimAction(Constants.ACTION_JOG);

			theHero = hero;

			camHolder.transform.position = hero.gameObject.transform.position;
			camHolder.transform.parent = null;
		}
	}

	void Hero2(Hero hero) {
		if (hero!=null) {
			hero.MoveTo( new Vector3(loc.x + 4,0,loc.z + 4) );
			hero.AssignTimedMecanimAction(Constants.ACTION_JOG, 0.1f);
		}
	}

	void Hero3(Hero hero) {
		if (hero!=null) {
			hero.MoveTo( new Vector3(loc.x - 3.5f,0,loc.z + 6) );
			hero.AssignTimedMecanimAction(Constants.ACTION_JOG, 0.05f);
		}
	}
	
}
