﻿using UnityEngine;
using System.Collections;

public class Panel_WorldRotate : Panel {
	private GameObject camHolder;

	public Panel_WorldRotate() {
		Debug.Log("Current Panel: World Rotate");

		// set panel time
		panelTime = 10.0f;
		
		// make a reference to the GameController
		GameController controller = GameObject.FindGameObjectWithTag("GameController").GetComponent<GameController>();
		
		// change camera
		controller.ShowRotatingCam();
		
		// position camera
		Camera cam = controller.rotatingCam;
		cam.transform.localPosition = new Vector3(0,150,-350);
		cam.transform.LookAt( new Vector3() );
		
		// parent camera to current hero
		camHolder = controller.rotatingCamHolder;
		camHolder.transform.position = new Vector3();
		camHolder.transform.eulerAngles = new Vector3();
		camHolder.transform.parent = null;
		
		// point to the center of the world
		camHolder.transform.position = new Vector3();
		
		
		// populate with heroes;
		heroes = HeroManager.getRandomHeroes(5);
		if (heroes != null) {
			// physically place hero
			for (int i=0; i<heroes.Count; i++) {
				heroes[i].ShowHero();
			}
			
			Hero1(heroes[0]);
			Hero2(heroes[1]);
			Hero3(heroes[2]);
			Hero4(heroes[3]);
			Hero5(heroes[4]);
			
		}
	}
	
	public override void UpdatePanel() {
		// rotate the camera
		camHolder.transform.eulerAngles = new Vector3(camHolder.transform.eulerAngles.x, camHolder.transform.eulerAngles.y + 2.0f*Time.deltaTime, camHolder.transform.eulerAngles.z);

		base.UpdatePanel();
	}
	
	public override void EndPanel() {

		// call parent
		base.EndPanel();
	}
	
	
	
	// Hero Specific Actions -----------------------------------------------
	void Hero1(Hero hero) {
		if (hero!=null) {
			hero.MoveTo(new Vector3(0,140,0 ) );
			hero.AssignBlenderAction(Constants.ACTION_FLYING_POSE1);
			
			
			hero.RotateTo( new Vector3(0,-90,0) );
			hero.AnimateForward(40);
		}
	}
	
	void Hero2(Hero hero) {
		if (hero!=null) {
			hero.MoveTo(new Vector3(180,140,180 ) );
			hero.AssignBlenderAction(Constants.ACTION_FLYING_POSE1);
			
			
			hero.RotateTo( new Vector3(0,45,0) );
			hero.AnimateForward(40);
		}
	}
	
	void Hero3(Hero hero) {
		if (hero!=null) {
			hero.MoveTo(new Vector3(80,140,80 ) );
			hero.AssignBlenderAction(Constants.ACTION_FLYING_POSE1);
			//hero.RotateTo( new Vector3(0,20,0) );
			hero.RotateTo( new Vector3(10,30,0) );
			hero.AnimateForward(40);
		}
	}
	
	void Hero4(Hero hero) {
		if (hero!=null) {
			hero.MoveTo(new Vector3(100,135,14 ) );
			hero.AssignBlenderAction(Constants.ACTION_FLYING_POSE1);
			//hero.RotateTo( new Vector3(0,30,0) );
			hero.RotateTo( new Vector3(-5,133,0) );
			hero.AnimateForward(40);
		}
	}
	
	void Hero5(Hero hero) {
		if (hero!=null) {
			hero.MoveTo(new Vector3(0,150,0 ) );
			hero.AssignBlenderAction(Constants.ACTION_FLYING_POSE1);
			hero.RotateTo( new Vector3(0,-75,0) );
			hero.AnimateForward(40);
			
		}
	}
	
	
	
	
}
